package com.maroontress.madangler.client;

import com.google.gwt.http.client.Request;
import com.google.gwt.http.client.Response;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.SimplePanel;
import com.google.gwt.user.client.ui.SourcesTabEvents;
import com.google.gwt.user.client.ui.TabBar;
import com.google.gwt.user.client.ui.TabListener;
import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.xml.client.DOMException;
import com.google.gwt.xml.client.Element;
import com.google.gwt.xml.client.NodeList;
import com.maroontress.madangler.client.config.ConfigModel;
import com.maroontress.madangler.client.config.GenericPanel;
import com.maroontress.madangler.client.config.MailPanel;
import com.maroontress.madangler.client.config.PlatformsPanel;
import com.maroontress.madangler.client.request.Parameters;
import com.maroontress.madangler.client.request.RequestKit;
import com.maroontress.madangler.client.request.RequestListener;

/**
   ץΥѥͥǤ
*/
public class ProjectConfigPanel extends SubPanel {

    /** ꥭ󥻥γǧå */
    private static final String CANCEL_CONFIRMATION
        = "You are about to cancel without saving changes. "
	+ "Are you sure you want to continue?";

    /** CSSֻ̾ */
    private static final String STYLE_PREFIX = "projectConfigPanel-";

    /** 󥻥ܥ */
    private Button cancelButton;

    /** ܥ */
    private Button submitButton;

    /** ץΥǥ */
    private ConfigModel model;

    /** Υѥͥ */
    private GenericPanel genericPanel;

    /** ܥȥץѥͥδ֤η */
    private HTML footer;

    /** ᡼Υѥͥ */
    private MailPanel mailPanel;

    /** ʥӥ */
    private Navigation navi;

    /** ץåȥեΥѥͥ */
    private PlatformsPanel platformsPanel;

    /** ץȥȥѥͥ */
    private ProjectTitlePanel projectTitle;

    /** ꥯȥå */
    private RequestKit kit;

    /** getPropteryꥯȥꥹ */
    private RequestListener loadedListener;

    /** setPropertyꥯȥꥹ */
    private RequestListener submittedListener;

    /** ץѥͥ */
    private SimplePanel sp;

    /** ץȤID */
    private String id;

    /** ԽΥǥXML */
    private String lastModelXML;

    /** ֥С */
    private TabBar bar;

    /**
       ץѥͥޤ
    */
    public ProjectConfigPanel() {
	navi = new Navigation("Configure Project");
	navi.setLink(new Link("config"));

	projectTitle = new ProjectTitlePanel();
	add(projectTitle);
	add(new HTML("&nbsp;"));

	model = new ConfigModel();
	genericPanel = new GenericPanel(model);
	platformsPanel = new PlatformsPanel(model);
	mailPanel = new MailPanel(model);

	bar = new TabBar();
        bar.setStyleName(STYLE_PREFIX + "TabBar");
        bar.addTabListener(new TabListener() {
            public boolean onBeforeTabSelected(final SourcesTabEvents sender,
                                               final int tabIndex) {
                return true;
            }
            public void onTabSelected(final SourcesTabEvents sender,
                                      final int tabIndex) {
		if (tabIndex == 0) {
		    sp.setWidget(genericPanel);
		} else if (tabIndex == 1) {
		    sp.setWidget(platformsPanel);
		} else if (tabIndex == 2) {
		    sp.setWidget(mailPanel);
		}
            }
        });
	genericPanel.setStyleName(STYLE_PREFIX + "SubPanel");
	platformsPanel.setStyleName(STYLE_PREFIX + "SubPanel");
	mailPanel.setStyleName(STYLE_PREFIX + "SubPanel");
	bar.addTab("Generic");
	bar.addTab("Platforms");
	bar.addTab("Mail");
	add(bar);

	sp = new SimplePanel();
	sp.setStyleName(STYLE_PREFIX + "SimplePanel");
	add(sp);

	footer = new HTML("&nbsp;");
	add(footer);

	cancelButton = new Button("Cancel");
	cancelButton.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		cancelConfig();
	    }
	});

	submitButton = new Button("Submit");
	submitButton.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		submitConfig();
	    }
	});

	HorizontalPanel bp = new HorizontalPanel();
	HTML space = new HTML("&nbsp;");
	bp.add(cancelButton);
	bp.add(space);
	bp.add(submitButton);
	bp.setCellWidth(space, "100%");
	bp.setWidth("100%");
	add(bp);

	kit = new RequestKit();
        loadedListener = new RequestListener() {
	    public void startRequest() {
		MadAngler.setLoading(true);
	    }
	    public void stopRequest() {
		MadAngler.setLoading(false);
	    }
	    public void responseReceived(final Request req,
					 final Response res) {
		if (parseGetPropertyResponse(res.getText()) < 0) {
		    cancelConfig();
		    return;
		}
		enableInteraction(true);
	    }
	    public void errorThrown(final Request req,
				    final Throwable e) {
		Window.alert(e.getMessage());
		notifyCanceled();
	    }
	};
        submittedListener = new RequestListener() {
	    public void startRequest() {
		MadAngler.setLoading(true);
	    }
	    public void stopRequest() {
		MadAngler.setLoading(false);
	    }
	    public void responseReceived(final Request req,
					 final Response res) {
		if (parseSetPropertyResponse(res.getText()) < 0) {
		    return;
		}
		notifySubmitted(id, null);
	    }
	    public void errorThrown(final Request req,
				    final Throwable e) {
		Window.alert(e.getMessage());
		notifyCanceled();
	    }
        };
    }

    /**
       ǽǽˤޤ

       @param b trueǽfalseǽ
    */
    private void enableInteraction(final boolean b) {
        bar.setVisible(b);
        sp.setVisible(b);
	cancelButton.setEnabled(b);
	submitButton.setEnabled(b);
	if (b) {
	    MadAngler.resize();
	}
    }

    /**
       getProptery쥹ݥ󥹤ѡޤ

       @param text getProptery쥹ݥ
       @return 0Ǥʤ-1
    */
    private int parseGetPropertyResponse(final String text) {
	Status status;
        try {
	    status = new Status(text);
        } catch (DOMException e) {
            Window.alert(e.getMessage());
            return -1;
        }
	if (status.getCode() != 0) {
            Window.alert(status.getMessage());
            return -1;
	}
	Element prop = status.getFirstChildNode("property");
	if (prop == null) {
            Window.alert("response has no property element.");
            return -1;
	}
	model.clear();
	model.setPropertyElement(prop);
        NodeList nl = status.getChildNodes("platform");
	for (int k = 0; k < nl.getLength(); ++k) {
	    Element plat = (Element) nl.item(k);
	    model.addPlatformElement(plat);
        }
	model.notifyChanged();
	lastModelXML = model.getXML();
	return 0;
    }

    /**
       ߤޤ
    */
    private void cancelConfig() {
	if (navigationClicked()) {
	    notifyCanceled();
	}
    }

    /**
       ¸ޤ
    */
    private void submitConfig() {
	Parameters params = new Parameters();
	params.add("method", "setProperty");
	params.add("projectId", id);
	params.add("projectConfig", model.getXML());
	kit.sendRequest(params.toString(), submittedListener);
    }

    /**
       setProperty쥹ݥ󥹤ѡޤ

       @param text setProptery쥹ݥ
       @return 0Ǥʤ-1
    */
    private int parseSetPropertyResponse(final String text) {
	Status status;
        try {
	    status = new Status(text);
        } catch (DOMException e) {
            Window.alert(e.getMessage());
            return -1;
        }
	if (status.getCode() != 0) {
            Window.alert(status.getMessage());
            return -1;
	}
	return 0;
    }

    /**
       ѥͥΥꤷޤ

       @param width 
       @param height ⤵
    */
    public void adjustSize(int width, int height) {
	/* The value that this.getOffsetHeight() returns makes no sense. */
	int yEnd = (submitButton.getAbsoluteTop()
		    + submitButton.getOffsetHeight());
	int footerHeight = yEnd - footer.getAbsoluteTop();

	width -= 2 * sp.getAbsoluteLeft();
	if (width < 1) {
	    width = 1;
	}
	height -= sp.getAbsoluteTop() + 4 + footerHeight;
	if (height < 1) {
	    height = 1;
	}
	sp.setPixelSize(width, height);
    }

    /**
       {@inheritDoc}
    */
    public Navigation getNavigation() {
	return navi;
    }

    /**
       {@inheritDoc}
    */
    public void setLink(final Link link) {
	id = link.getParameter("id");
	String template = link.getParameter("template");
	String tab = link.getParameter("tab");

	lastModelXML = null;
	projectTitle.setProjectId(id);
	genericPanel.setProjectId(id);
	platformsPanel.reset();
	bar.selectTab((tab == null) ? 0 : Integer.parseInt(tab));
	enableInteraction(false);

	Parameters params = new Parameters();
	params.add("method", "getProperty");
	params.add("projectId", (template != null) ? template : id);
	kit.sendRequest(params.toString(), loadedListener);

	navi.setLink(link);
    }

    /**
       {@inheritDoc}
    */
    public boolean navigationClicked() {
	// OK () --> true
	// Cancel (ʤ) --> false
	return (lastModelXML == null
		|| model.getXML().equals(lastModelXML)
		|| Window.confirm(CANCEL_CONFIRMATION));
    }
}
