package com.maroontress.madangler.client;

import com.google.gwt.http.client.Request;
import com.google.gwt.http.client.Response;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.xml.client.DOMException;
import com.google.gwt.xml.client.Document;
import com.google.gwt.xml.client.Element;
import com.google.gwt.xml.client.NodeList;
import com.google.gwt.xml.client.XMLParser;
import com.maroontress.madangler.client.request.Parameters;
import com.maroontress.madangler.client.request.RequestKit;
import com.maroontress.madangler.client.request.RequestListener;

/**
   ץȰΥѥͥǤ
*/
public class ProjectListPanel extends SubPanel {

    /** ܥ¤٤ġڥ */
    private HorizontalPanel tools;

    /** ʥӥ */
    private Navigation navi;

    /** ץȤΥơ֥ */
    private ProjectTable projTable;

    /** ɽ */
    private PublicKeyDialog dialog;

    /** ꥯȥå */
    private RequestKit kit;

    /** deleteProjectꥯȤΥꥹ */
    private RequestListener deletedListener;

    /** listProjectsꥯȤΥꥹ */
    private RequestListener loadedListener;

    /**
       ץȥꥹȥѥͥޤ
    */
    public ProjectListPanel() {
	navi = new Navigation("Projects");
	navi.setLink(new Link("projects"));

	tools = new HorizontalPanel();
        Image reload = new Image("images/reload.png");
	reload.setStyleName("imageButton");
	reload.setTitle("Reload");
        reload.addClickListener(new ClickListener() {
            public void onClick(final Widget sender) {
		loadProjects();
            }
        });
        tools.add(reload);
        Image pubkey = new Image("images/pubkey.png");
	pubkey.setStyleName("imageButton");
	pubkey.setTitle("Show public key");
        pubkey.addClickListener(new ClickListener() {
            public void onClick(final Widget sender) {
		showPublicKey();
            }
        });
        tools.add(pubkey);
        add(tools);
	add(new HTML("&nbsp;"));

	projTable = new ProjectTable();
	projTable.setProjectTableListener(new ProjectTableListener() {
	    public void deleteProject(final ProjectTable table,
				      final String id) {
		if (!Window.confirm("Do you want to delete '" + id
				    + "' project?")) {
		    return;
		}
		removeProject(id);
	    }
	});
	projTable.setCellSpacing(0);
	// projTable.setCellPadding(0);
	add(projTable);

	setWidth("100%");

	dialog = new PublicKeyDialog();

	kit = new RequestKit();
        loadedListener = new RequestListener() {
	    public void startRequest() {
		setLoading(true);
	    }
	    public void stopRequest() {
		setLoading(false);
	    }
	    public void responseReceived(final Request req,
					 final Response res) {
		parseListProjectsResponse(res.getText());
	    }
	    public void errorThrown(final Request req,
				    final Throwable e) {
		Window.alert(e.getMessage());
	    }
	};
        deletedListener = new RequestListener() {
	    public void startRequest() {
		setLoading(true);
	    }
	    public void stopRequest() {
		setLoading(false);
	    }
	    public void responseReceived(final Request req,
					 final Response res) {
		Status s = new Status(res.getText());
		if (s.getCode() < 0) {
		    Window.alert(s.getMessage());
		    return;
		}
		Window.alert("Successfully deleted.");
		loadProjects();
	    }
	    public void errorThrown(final Request req,
				    final Throwable e) {
		Window.alert(e.getMessage());
	    }
	};
    }

    /**
       ץȤޤ

       @param id ץȤID
    */
    private void removeProject(final String id) {
	Parameters params = new Parameters();
	params.add("method", "deleteProject");
	params.add("projectId", id);
	kit.sendRequest(params.toString(), deletedListener);
    }

    /**
       ̿桢̿ξ֤ꤷޤ

       @param b true̿桢false̿
    */
    private void setLoading(final boolean b) {
        MadAngler.setLoading(b);
        tools.setVisible(!b);
	projTable.setVisible(!b);
    }

    /**
       ơ֥򥯥ꥢơץȰƼޤ
    */
    public void loadProjects() {
	projTable.clearProject();

	Parameters params = new Parameters();
	params.add("method", "listProjects");
	kit.sendRequest(params.toString(), loadedListener);
    }

    /**
       listProjects쥹ݥ󥹤ѡơơ֥򹹿ޤ

       @param text listProjects쥹ݥ
    */
    private void parseListProjectsResponse(final String text) {
        Document d;
        try {
            d = XMLParser.parse(text);
        } catch (DOMException e) {
            Window.alert(e.getMessage());
            return;
        }
        NodeList nl = d.getElementsByTagName("project");
        for (int k = 0; k < nl.getLength(); ++k) {
            Element project = (Element) nl.item(k);
            String name = project.getAttribute("name");
            String desc = project.getAttribute("description");
	    projTable.addProject(name, desc);
        }
    }

    /**
       ɽޤ
    */
    private void showPublicKey() {
	dialog.center();
    }

    /**
       {@inheritDoc}
    */
    public Navigation getNavigation() {
	return navi;
    }

    /**
       {@inheritDoc}
    */
    public void setLink(final Link link) {
	navi.setLink(link);
    }
}
